#ifndef __EPD_H__
#define __EPD_H__

#include "epd_common.h"

#define EPD_WIDTH  400
#define EPD_HEIGHT 300

#define EPD_COLOR   0x00
#define EPD_UNCOLOR 0xFF

/*
ɫ/ɫ bw(uncolor) + xw(uncolor)
            bw(color) + xw(uncolor)
ɫ bw(uncolor) + xw(color)
ɫ bw(color) + xw(color)
*/

typedef struct __epd_rect
{
    epd_uint16_t x;
    epd_uint16_t y;
    epd_uint16_t width;
    epd_uint16_t height;
} epd_rect_t;

typedef enum __epd_fill_color_channel
{
    epd_fill_bw_ch,
    epd_fill_xw_ch
} epd_fill_color_channel_t;

void epd_reset();
void epd_init();
void epd_send_command(epd_uint8_t epd_command);
void epd_send_data(epd_uint8_t epd_data);
void epd_wait_until_idle();

// ˢīˮRAMڵݳֵīˮ
void epd_refresh();

/* 3ûȡˢɫڲˢ */
void epd_set_clear_color(epd_uint8_t bw_ch, epd_uint8_t xw_ch);
void epd_get_clear_color(epd_uint8_t* bw_ch, epd_uint8_t* xw_ch);
void epd_clear();

/* 4䴿ɫͼƬڲˢ */
void epd_fill_color(epd_fill_color_channel_t channel, epd_uint8_t color);
void epd_fill_image(epd_fill_color_channel_t channel, const epd_uint8_t* image);
void epd_fill_color_with_rect(epd_fill_color_channel_t channel, epd_uint8_t color, epd_rect_t rect);
void epd_fill_image_with_rect(epd_fill_color_channel_t channel, const epd_uint8_t* image, epd_rect_t rect);

// !!! û¸ʱ˯
// µ epd_init()
void epd_sleep();

#endif
