#ifndef __EPD_COMMAND_H__
#define __EPD_COMMAND_H__

#include "epd_common.h"

// 4.2Ӣ ɫīˮ
// ο1: https://github.com/waveshareteam/e-Paper/blob/master/Arduino/epd4in2bc/epd4in2b.h
// ο2: UC8276C

#define DEF_EPD_CMD_U8(command) ((epd_uint8_t)command)

#define PANEL_SETTING                       DEF_EPD_CMD_U8(0x00)
#define POWER_SETTING                       DEF_EPD_CMD_U8(0x01)
#define POWER_OFF                           DEF_EPD_CMD_U8(0x02)
#define POWER_OFF_SEQUENCE_SETTING          DEF_EPD_CMD_U8(0x03)
#define POWER_ON                            DEF_EPD_CMD_U8(0x04)
#define POWER_ON_MEASURE                    DEF_EPD_CMD_U8(0x05)
#define BOOSTER_SOFT_START                  DEF_EPD_CMD_U8(0x06)
#define DEEP_SLEEP                          DEF_EPD_CMD_U8(0x07)
#define DATA_START_TRANSMISSION_1           DEF_EPD_CMD_U8(0x10)
#define DATA_STOP                           DEF_EPD_CMD_U8(0x11)
#define DISPLAY_REFRESH                     DEF_EPD_CMD_U8(0x12)
#define DATA_START_TRANSMISSION_2           DEF_EPD_CMD_U8(0x13)
#define LUT_FOR_VCOM                        DEF_EPD_CMD_U8(0x20)
#define LUT_WHITE_TO_WHITE                  DEF_EPD_CMD_U8(0x21)
#define LUT_BLACK_TO_WHITE                  DEF_EPD_CMD_U8(0x22)
#define LUT_WHITE_TO_BLACK                  DEF_EPD_CMD_U8(0x23)
#define LUT_BLACK_TO_BLACK                  DEF_EPD_CMD_U8(0x24)
#define PLL_CONTROL                         DEF_EPD_CMD_U8(0x30)
#define TEMPERATURE_SENSOR_COMMAND          DEF_EPD_CMD_U8(0x40)
#define TEMPERATURE_SENSOR_SELECTION        DEF_EPD_CMD_U8(0x41)
#define TEMPERATURE_SENSOR_WRITE            DEF_EPD_CMD_U8(0x42)
#define TEMPERATURE_SENSOR_READ             DEF_EPD_CMD_U8(0x43)
#define VCOM_AND_DATA_INTERVAL_SETTING      DEF_EPD_CMD_U8(0x50)
#define LOW_POWER_DETECTION                 DEF_EPD_CMD_U8(0x51)
#define TCON_SETTING                        DEF_EPD_CMD_U8(0x60)
#define RESOLUTION_SETTING                  DEF_EPD_CMD_U8(0x61)
#define GSST_SETTING                        DEF_EPD_CMD_U8(0x65)
#define GET_STATUS                          DEF_EPD_CMD_U8(0x71)
#define AUTO_MEASUREMENT_VCOM               DEF_EPD_CMD_U8(0x80)
#define READ_VCOM_VALUE                     DEF_EPD_CMD_U8(0x81)
#define VCM_DC_SETTING                      DEF_EPD_CMD_U8(0x82)
#define PARTIAL_WINDOW                      DEF_EPD_CMD_U8(0x90)
#define PARTIAL_IN                          DEF_EPD_CMD_U8(0x91)
#define PARTIAL_OUT                         DEF_EPD_CMD_U8(0x92)
#define PROGRAM_MODE                        DEF_EPD_CMD_U8(0xA0)
#define ACTIVE_PROGRAMMING                  DEF_EPD_CMD_U8(0xA1)
#define READ_OTP                            DEF_EPD_CMD_U8(0xA2)
#define POWER_SAVING                        DEF_EPD_CMD_U8(0xE3)

#endif
