#include "epd_hal.h"
#include <stc8h.h>

// epd_hal Ϊʵֲ֣ʱֻҪ޸epd_hal.cҪʱͬʱ޸epd_common.h


#define EPD_SPI_CS      P22
#define EPD_SPI_MOSI    P23
#define EPD_SPI_SCLK    P25
#define EPD_IO_DC       P20
#define EPD_IO_RESET    P21
#define EPD_IO_BUSY     P26

void epd_hal_io_init()
{
    P2M0 = 0x2f;
    P2M1 = 0xd0;
    P2PU = 0x40;
    
    EPD_SPI_CS = 1;
    EPD_SPI_MOSI = 0;
    EPD_SPI_SCLK = 0;
    EPD_IO_DC = 1;
    EPD_IO_RESET = 1;
    
    // SPI ѡ P22 ~ P25
    P_SW1 = (P_SW1 & ~0x0c) | 0x04;
}

void epd_hal_io_write_dc(epd_io_level_t io_level)
{
    EPD_IO_DC = io_level;
}

void epd_hal_io_write_reset(epd_io_level_t io_level)
{
    EPD_IO_RESET = io_level;
}

epd_io_level_t epd_hal_io_read_busy()
{
    return EPD_IO_BUSY;
}

#define SPI_SCLK_DIV_4 0x00
#define SPI_SCLK_DIV_8 0x01
#define SPI_SLCK_DIV_16 0x02
#define SPI_SCLK_DIV_32 0x03

void epd_hal_spi_init()
{
    SPCTL = 0xD0;
    // sysclk(44.2368MHz)/16Լ2.7648MHz
    SPCTL |= SPI_SLCK_DIV_16;
    // SPIж
    IE2 &= ~(1<<1);
}

#define	SPIF 0x80   /* SPIɱ־д10*/
#define	WCOL 0x40   /* SPIдͻ־д10  */

void epd_hal_spi_transmite(epd_uint8_t spi_data)
{
    EPD_SPI_CS = EPD_IO_LOW;
    EPD_SPI_CS = EPD_IO_LOW;
    EPD_SPI_CS = EPD_IO_LOW;
    SPDAT = spi_data;
    while (!(SPSTAT & 0x80));
    SPSTAT = SPIF + WCOL;
    EPD_SPI_CS = EPD_IO_HIGH;
}



// οɿƼ STC8H 
// οhttps://gitee.com/seekfree/STC8H8K64_Library/blob/master/Seekfree_STC8H8K64x_Opensource_Library/Libraries/libraries/board.c

#define IRC_22M (*((volatile epd_uint8_t  idata*)0xFA))
#define IRC_24M (*((volatile epd_uint8_t  idata*)0xFB))

epd_uint32_t sys_clk;

void epd_hal_delay_init()
{
    epd_uint32_t temp_count;
	P_SW2 |= 0x80;
	
	if(IRCBAND)
		temp_count = 36000000UL + ((epd_int32_t)((epd_int32_t)IRTRIM - (epd_int32_t)IRC_22M) * 0x128E0UL);
	else
		temp_count = 24000000UL + ((epd_int32_t)((epd_int32_t)IRTRIM - (epd_int32_t)IRC_24M) * 0xBB80UL);
	
		temp_count /= CLKDIV;
	
    sys_clk = 24000000UL;
    
	if 	(temp_count < 5764800UL)
		sys_clk = 5529600UL;
	else if(temp_count < 8529600UL)
		sys_clk = 6000000UL;
	else if(temp_count < 11529600UL)
		sys_clk = 11059200UL;
	else if(temp_count < 15216000UL)
		sys_clk =  12000000UL;
	else if(temp_count < 19216000UL)
		sys_clk =  18432000UL;
	else if(temp_count < 21059200UL)
		sys_clk =  20000000UL;
	else if(temp_count < 23059200UL)
		sys_clk =  22118400UL;
	else if(temp_count < 25500000UL)
		sys_clk =  24000000UL;
	else if(temp_count < 28500000UL)
		sys_clk =  27000000UL;
	else if(temp_count < 31500000UL)
		sys_clk =  30000000UL;
	else if(temp_count < 33500000UL)
		sys_clk =  33177600UL;
	else if(temp_count < 35932000UL)
		sys_clk =  35000000UL;
	else if(temp_count < 38432000UL)
		sys_clk =  36864000UL;
	else if(temp_count < 42000000UL)
		sys_clk =  40000000UL;
	else if(temp_count < 46000000UL)
		sys_clk =  44236800UL;
	else 
		sys_clk = 48000000UL;
}

void epd_hal_delay_ms(epd_uint8_t ms)
{
    unsigned int i, c;
    c = sys_clk / 10000UL;
	do {
		i = c;
		while(--i);
	} while(--ms);
}
